--Unija, presek, razlika

--Prikazati broj bodova i nazive svih predmeta ako predmeti pripadaju grupi Analiza, 
--ili su polagani u januarskom ispitnom roku 2015. godine.
--Predmeti mogu da zadovolje i oba prethodno navedena uslova.
--Izvestaj treba da bude uredjen po opadajucem redosledu broja bodova koji predmeti nose 

select naziv,bodovi 
from   predmet
where  naziv like 'Analiza%'

union  all

select naziv,a.bodovi 
from   predmet a, ispit b
where  a.id_predmeta=b.id_predmeta
and    godina_roka=2015
and    oznaka_roka='jan'
order by bodovi desc;



--Prikazati broj bodova i nazive svih predmeta ako predmeti pripadaju grupi Analiza, 
--ili su polagani u januarskom ispitnom roku 2015. godine.
--Predmeti mogu da zadovolje i oba prethodno navedena uslova.
--Nazivi predmeta i njihovi bodovi u rezultujucoj tabeli treba da se javljaju tacno jednom.
--Izvestaj treba da bude uredjen po opadajucem redosledu broja bodova koji predmeti nose 

select naziv,bodovi 
from   predmet
where  naziv like 'Analiza%'

union  

select naziv,a.bodovi 
from   predmet a, ispit b
where  a.id_predmeta=b.id_predmeta
and    godina_roka=2015
and    oznaka_roka='jan'
order by bodovi desc;



--Prikazati brojeve indeksa, imena, prezimena i mesto rodjenja svih studenata 
--koji su rodjeni posle 1991. godine. U slucaju da je mesto rodjenja studenta nepoznato, 
--kao mesto rodjenja prijaviti 'Nepoznato mesto'
--Da li je vazan redosled select upita pri union operaciji?
select indeks,ime,prezime,mesto_rodjenja
from   dosije
where  year(datum_rodjenja)>1991
and    mesto_rodjenja is not null

union  

select indeks,ime,prezime,'Nepoznato mesto'
from   dosije
where  year(datum_rodjenja)>1991
and    mesto_rodjenja is null;




--Prikazati broj bodova i nazive svih predmeta koji pripadaju grupi Analiza, 
--i polagani su u januarskom ispitnom roku 2015. godine.
--Izvestaj treba da bude uredjen po opadajucem redosledu broja bodova koji predmeti nose 

select naziv,bodovi 
from   predmet
where  naziv like 'Analiza%'

intersect 

select naziv,a.bodovi 
from   predmet a, ispit b
where  a.id_predmeta=b.id_predmeta
and    godina_roka=2015
and    oznaka_roka='jan'
order by bodovi desc;


--Prikazati broj bodova i nazive svih predmeta koji pripadaju grupi Analiza, 
--ali nisu polagani u januarskom ispitnom roku 2015. godine.
--Izvestaj treba da bude uredjen po opadajucem redosledu broja bodova koji predmeti nose 
--Umesto EXCEPT moze da se koristi i MINUS
select naziv,bodovi 
from   predmet
where  naziv like 'Analiza%'

except

select naziv,a.bodovi 
from   predmet a, ispit b
where  a.id_predmeta=b.id_predmeta
and    godina_roka=2015
and    oznaka_roka='jan'
order by bodovi desc;
